package cn.com.qmth.scancloud.dao;

import cn.com.qmth.scancloud.bean.BatchQueryDomain;
import cn.com.qmth.scancloud.entity.BatchEntity;
import cn.com.qmth.scancloud.enums.BatchStatus;
import cn.com.qmth.scancloud.enums.CheckStatus;
import cn.com.qmth.scancloud.enums.VerifyStatus;
import cn.com.qmth.scancloud.vo.BatchQueryVo;
import cn.com.qmth.scancloud.vo.ScannerWorkloadVo;
import cn.com.qmth.scancloud.vo.batchdetail.BatchDetailDO;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import org.apache.ibatis.annotations.Param;

import java.util.List;

public interface BatchDao extends BaseMapper<BatchEntity> {

    void updateScanCount(@Param("id") Long id);

    void updateAssignedCount(@Param("id") Long id);

    List<Long> batchSummary(@Param("query") BatchQueryDomain query);

    IPage<BatchQueryVo> batchQueryPage(Page<BatchQueryVo> page, @Param("query") BatchQueryDomain query);

    List<BatchDetailDO> batchDetailList(@Param("id") Long id);

    IPage<BatchEntity> findUnVerify(Page<BatchEntity> page, @Param("examId") Long examId,
            @Param("status") VerifyStatus status);

    Integer findStudentCountByBatch(@Param(value = "batchId") Long batchId);

    List<String> batchScanner(@Param("examId") Long examId);

    List<ScannerWorkloadVo> workload(@Param(value = "examId") Long examId, @Param(value = "startTime") Long startTime,
            @Param(value = "endTime") Long endTime);

    IPage<BatchEntity> findUnCheck(Page<BatchEntity> page,@Param("examId") Long examId,@Param("batchStatus")BatchStatus batchStatus,@Param("checkStatus") CheckStatus checkStatus);

    List<BatchDetailDO> batchDetailListToCheck(@Param("id")Long id,@Param("needCheck")Boolean needCheck);

    BatchEntity getHistory(@Param(value = "examId")Long examId,@Param("batchId") Long batchId,@Param("userId") Long userId,@Param("status") CheckStatus status);

}
