package cn.com.qmth.scancloud.dao;

import cn.com.qmth.scancloud.bean.AbsentQueryDomain;
import cn.com.qmth.scancloud.bean.AnswerQueryDomain;
import cn.com.qmth.scancloud.entity.StudentEntity;
import cn.com.qmth.scancloud.vo.*;
import cn.com.qmth.scancloud.vo.answerquery.AnswerQueryVo;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import org.apache.ibatis.annotations.Param;

import java.util.List;

public interface StudentDao extends BaseMapper<StudentEntity> {

    List<CampusVo> listCampusByExamId(@Param("examId") Long examId);

    List<ExamSiteVo> listSiteByExamId(@Param("examId") Long examId);

    AbsentInfoVo absentInfo(@Param("examId") Long examId, @Param("groupType") String groupType,
            @Param("groupName") String groupName);

    List<String> absentQuerySummary(@Param("groupNameCol") String groupNameCol,
            @Param("query") AbsentQueryDomain query);

    IPage<AbsentQueryVo> absentQueryPage(Page<AbsentQueryVo> page, @Param("groupNameCol") String groupNameCol,
            @Param("query") AbsentQueryDomain query);

    List<AbsentQueryVo> absentExportList(Page<AbsentQueryVo> page, @Param("groupNameCol") String groupNameCol,
            @Param("query") AbsentQueryDomain query);

    IPage<AnswerQueryVo> queryPage(Page<AnswerQueryVo> page, @Param("query") AnswerQueryDomain query);

    List<String> querySummary(@Param("query") AnswerQueryDomain query);

    List<AnswerExportVo> exportList(Page<AnswerQueryVo> page, @Param("query") AnswerQueryDomain query);

    List<StudentUploadVo> findToUpload(@Param("pageSize") Integer pageSize, @Param("schoolId") Long schoolId);

    List<StudentUploadVo> findUploadError(@Param("pageSize") Integer pageSize, @Param("schoolId") Long schoolId);

    int getPackageCountByExam(@Param("examId") Long examId);

    int countByQuery(@Param("query") ImportStudentQueryVo query);

    IPage<ImportStudentVo> listPageQuery(Page<ImportStudentVo> page, @Param("query") ImportStudentQueryVo query);

    List<StudentUploadVo> findToPictureCopy(@Param("pageSize") Integer pageSize);

    int getUploadedCount(@Param("examId") Long examId);

    int getNeedUploadCount(@Param("examId") Long examId);

    IPage<ExportCetVo> listCetMarkingPage(Page<ExportCetVo> page, @Param("query") ExportCetMarkingQueryVo query);

    ScanAnswerInfoVo getInfoCountByExam(@Param("examId") Long examId);

}
