package cn.com.qmth.scancloud.service;

import cn.com.qmth.scancloud.bean.MismatchQueryDomain;
import cn.com.qmth.scancloud.bean.MismatchToggleDomain;
import cn.com.qmth.scancloud.bean.User;
import cn.com.qmth.scancloud.bean.papermigrate.PaperMigrateDomain;
import cn.com.qmth.scancloud.entity.PaperEntity;
import cn.com.qmth.scancloud.entity.PaperPageEntity;
import cn.com.qmth.scancloud.vo.MismatchToggleVo;
import cn.com.qmth.scancloud.vo.PaperMigrateVo;
import cn.com.qmth.scancloud.vo.UriVo;
import cn.com.qmth.scancloud.vo.answerquery.StudentPaperVo;
import cn.com.qmth.scancloud.vo.mismatchquery.MismatchQueryVo;
import cn.com.qmth.scancloud.vo.paper.PaperCetVo;
import cn.com.qmth.scancloud.vo.paper.PaperVo;
import com.baomidou.mybatisplus.extension.service.IService;
import com.qmth.boot.core.collection.PageResult;
import org.springframework.web.multipart.MultipartFile;

import java.util.List;

/**
 * 鉴权
 */
public interface PaperService extends IService<PaperEntity> {

    void savePaperAndPages(PaperEntity paper, List<PaperPageEntity> pages);

    List<PaperVo> findStudentPaper(Long studentId);

    boolean updateMismatch(Long id, boolean mismatch);

    int getMismatchCountByExam(Long examId);

    PageResult<MismatchQueryVo> mismatchQuery(MismatchQueryDomain query);

    MismatchToggleVo mismatchToggle(MismatchToggleDomain domain);

    List<StudentPaperVo> listByStudentIds(List<Long> paramList);

    UriVo adminSliceUpload(Long paperId, Integer pageIndex, Integer index, MultipartFile file, String md5);

    UriVo adminSliceUpdate(Long paperId, Integer pageIndex, Integer index, MultipartFile file, String md5);

    int getCountByExamAndCardNumber(Long examId, Integer number);

    PaperMigrateVo paperMigrate(User user, PaperMigrateDomain domain);

    UriVo adminSheetUpdate(Long paperId, Integer pageIndex, MultipartFile file, String md5);

    List<PaperCetVo> findByStudentIds(List<Long> studentIds);
}
