package cn.com.qmth.scancloud.service;

import cn.com.qmth.scancloud.bean.*;
import cn.com.qmth.scancloud.bean.omredit.OmrEditDomain;
import cn.com.qmth.scancloud.bean.refix.AnswerRefixDomain;
import cn.com.qmth.scancloud.entity.StudentEntity;
import cn.com.qmth.scancloud.entity.StudentPaperEntity;
import cn.com.qmth.scancloud.enums.GroupType;
import cn.com.qmth.scancloud.enums.ScanStatus;
import cn.com.qmth.scancloud.enums.UploadStatus;
import cn.com.qmth.scancloud.vo.*;
import cn.com.qmth.scancloud.vo.answerquery.AnswerQueryVo;
import cn.com.qmth.scancloud.vo.student.StudentQuery;
import cn.com.qmth.scancloud.vo.student.StudentVo;
import com.baomidou.mybatisplus.extension.service.IService;
import com.qmth.boot.core.collection.PageResult;
import org.springframework.web.multipart.MultipartFile;

import java.util.Collection;
import java.util.List;

public interface StudentService extends IService<StudentEntity> {

    void updateStudentByPaper(User user, Long id, boolean updateOmrTask);

    void updateStudentAndPaper(User user, Long id, List<StudentPaperEntity> studentPaperList);

    AnswerDeleteVo answerDelete(User user, AnswerDeleteDomain domain);

    PaperDeleteVo paperDelete(User user, PageDeleteDomain domain);

    List<CampusVo> listCampusByExamId(Long examId);

    List<ExamSiteVo> listSiteByExamId(Long examId);

    StudentVo findOne(StudentQuery query);

    int getCountByExam(Long examId);

    int getCountByExamAndScanStatus(Long examId, ScanStatus status);

    int getPackageCountByExam(Long examId);

    List<StudentVo> packageList(StudentQuery query);

    StudentEntity findByExamIdAndExamNumber(Long examId, String examNumber);

    List<StudentEntity> findByExamAndPackage(Long examId, String packageCode);

    int getAssignedCountByExam(Long examId);

    int getAbsentSuspectCountByExam(Long examId);

    int getIncompleteCountByExam(Long examId);

    AbsentInfoVo absentInfo(Long examId, GroupType groupType, String groupName);

    List<String> absentSummary(AbsentQueryDomain query);

    PageResult<AbsentQueryVo> absentQuery(AbsentQueryDomain query);

    AbsentManualImportVo absentManualImport(Long examId, MultipartFile file);

    UpdateTimeVo absentManualUpdate(Long examId, String examNumber);

    UpdateTimeVo absentSuspectUpdate(Long examId, String examNumber, boolean enable);

    ScanAnswerInfoVo scanAnswerInfo(Long examId);

    PageResult<AnswerQueryVo> query(AnswerQueryDomain query);

    List<String> summary(AnswerQueryDomain query);

    List<StudentUploadVo> findToUpload(int pageSize, Long schoolId);

    boolean existUploadData(Long schoolId);

    StudentEntity findByStudentCodeAndSubjectCode(Long examId, String studentCode, String subjectCode);

    List<AbsentQueryVo> absentExportList(AbsentQueryDomain query);

    List<AnswerExportVo> exportList(AnswerQueryDomain query);

    void updateDataUploadStatus(Long id, UploadStatus status);

    void updateUploadStatus(Long id, UploadStatus fileUploadStatus, UploadStatus dataUploadStatus);

    void updateFileUploadStatus(Long id, UploadStatus status);

    void updateOmrAbsent(Long id, Boolean omrAbsent);

    void deletetByExamIdAndUnCreateTime(Long examId, long createTime);

    int getCountByExamAndCardNumber(Long examId, Integer number);

    int importStudent(List<ImportStudentDomain> students);

    StudentEntity findByExamAndSubjectCodeAndStudentCode(Long examId, String subjectCode, String studentCode);

    int countByQuery(ImportStudentQueryVo query);

    List<ImportStudentVo> findByQuery(ImportStudentQueryVo query);

    int getOmrAbsentCountByExam(Long examId);

    boolean existPictureCopyData();

    List<StudentUploadVo> findToPictureCopy(int pageSize);

    Double getUploadProgress(Long examId);

    void studentClean(Long examId);

    AnswerRefixVo answerRefix(User user, AnswerRefixDomain domain);

    UpdateTimeVo omrEdit(User user, OmrEditDomain domain);

    Integer importCetAbsent(List<ImportCetAbsentDomain> students);

    List<ExportCetVo> exportCetData(ExportCetMarkingQueryVo query);

    Collection<AnswerExportK12Vo> exportListK12(AnswerQueryDomain query);
}
