package cn.com.qmth.scancloud.service.impl;

import java.util.Collection;
import java.util.HashMap;
import java.util.Map;

import org.apache.commons.collections4.CollectionUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import cn.com.qmth.scancloud.bean.SchoolSession;
import cn.com.qmth.scancloud.config.SysProperty;
import cn.com.qmth.scancloud.entity.SystemConfigEntity;
import cn.com.qmth.scancloud.enums.SystemMode;
import cn.com.qmth.scancloud.multithread.producer.UploadProducer;
import cn.com.qmth.scancloud.service.SessionService;
import cn.com.qmth.scancloud.service.StudentService;
import cn.com.qmth.scancloud.service.SystemConfigService;
import cn.com.qmth.scancloud.service.UploadService;

@Service
public class UploadServiceImpl implements UploadService {
	private static final Logger log = LoggerFactory.getLogger(UploadService.class);
	
	@Autowired
	private UploadProducer uploadProducer;
	
	@Autowired
	private SysProperty sysProperty;
	
	@Autowired
	private SessionService sessionService;
	
	@Autowired
	private SystemConfigService systemConfigService;
	
	@Autowired
	private StudentService studentService;
	

	@Override
	public void upload() {
		SystemConfigEntity conf=systemConfigService.findConfig();
    	if(!SystemMode.MARKING_CLOUD.equals(conf.getSystemMode())) {
    		return;
    	}
		try {
			Collection<SchoolSession> sss=sessionService.getSchoolSessions();
			if(CollectionUtils.isEmpty(sss)) {
				return;
			}
			Integer count=sysProperty.getThreadCount();
			if(count==null) {
				count=4;
			}
			for(SchoolSession ss:sss) {
				if(studentService.existUploadData(ss.getId())) {
					Map<String,Object> param=new HashMap<>();
					param.put("schoolId", ss.getId());
					uploadProducer.startDispose(count,param);
				}
			}
		} catch (Exception e) {
			log.error("上传任务出错", e);
		}
	}
}
